/* $Id: rk_iconv_defs.h,v 1.7 2021/08/15 16:51:15 tlaronde Exp $
 * Copyright 2004, 2014, 2021 Thierry LARONDE <tlaronde@polynum.com>
 * All rights reserved. 
 * 
 * Public domain
 *!!!THIS SOFTWARE IS PROVIDED ``AS IS'' WITHOUT ANY WARRANTIES!!! 
 *                     USE IT AT YOUR OWN RISK 
 ********************************************************************/
/* Some defined codeset. One version, taken from various sources.
 */ 
#ifndef RK_ICONV_DEFS_H
#define RK_ICONV_DEFS_H

#define RK_ICONV_ASCII "ASCII"
#define RK_ICONV_EBCDIC "EBCDIC"
#define RK_ICONV_UTF_8 "UTF-8"

#define RK_ICONV_ISO8859_1 "ISO8859-1" /* Western European---latin1 */
#define RK_ICONV_ISO8859_2 "ISO8859-2" /* Center European---latin2 */
#define RK_ICONV_ISO8859_3 "ISO8859-3" /* South European---latin3 */
#define RK_ICONV_ISO8859_4 "ISO8859-4" /* North European---latin4 */
#define RK_ICONV_ISO8859_5 "ISO8859-5" /* Latin/Cyrillic */
#define RK_ICONV_ISO8859_6 "ISO8859-6" /* Latin/Arabic */
#define RK_ICONV_ISO8859_7 "ISO8859-7" /* Latin/Greek */
#define RK_ICONV_ISO8859_8 "ISO8859-8" /* Latin/Hebrew */
#define RK_ICONV_ISO8859_9 "ISO8859-9" /* Turkish---latin5 */
#define RK_ICONV_ISO8859_10 "ISO8859-10" /* Nordic---latin6 */
#define RK_ICONV_ISO8859_13 "ISO8859-13" /* Baltic---latin7 */
#define RK_ICONV_ISO8859_14 "ISO8859-14" /* Celtic---latin8 */
#define RK_ICONV_ISO8859_15 "ISO8859-15" /* latin9: latin1 + Euro */
#define RK_ICONV_ISO8859_16 "ISO8859-16" /* Romanian---latin10 */

#define RK_ICONV_CP437 "CP437" /* ascii */
#define RK_ICONV_CP737 "CP737" /* Greek MS-DOS */
#define RK_ICONV_CP850 "CP850" /* latin1 */
#define RK_ICONV_CP852 "CP852" /* latin1? */
#define RK_ICONV_CP857 "CP857" /* Turkish MS-DOS */
#define RK_ICONV_CP860 "CP860" /* Portuguese */
#define RK_ICONV_CP861 "CP861" /* Icelandic MS-DOS */
#define RK_ICONV_CP863 "CP863" /* French (Canada) */
#define RK_ICONV_CP865 "CP865" /* Nordic MS-DOS */
#define RK_ICONV_CP866 "CP866" /* Russian MS-DOS */
#define RK_ICONV_CP874 "CP874" /* Thai (ANSI) */
#define RK_ICONV_CP932 "CP932" /* Japanese Shift-JIS */
#define RK_ICONV_CP936 "CP936" /* Chinese GBK (PRC) */
#define RK_ICONV_CP949 "CP949" /* Korean (ANSI) */
#define RK_ICONV_CP950 "CP950" /* Chinese Big 5 (Taiwan) */
#define RK_ICONV_CP1250 "CP1250" /* Central European; latin2 */
#define RK_ICONV_CP1251 "CP1251" /* Russian Windows */
#define RK_ICONV_CP1252 "CP1252" /* latin1+ */
#define RK_ICONV_CP1253 "CP1253" /* Greek Windows */
#define RK_ICONV_CP1254 "CP1254" /* Turkish Windows */
#define RK_ICONV_CP1255 "CP1255" /* Hebrew Windows */
#define RK_ICONV_CP1256 "CP1256" /* Arabic Windows */

#endif /* RK_ICONV_DEFS_H */
